---
title: Sensor APIs
slug: Web/API/Sensor_APIs
tags:
  - API
  - Generic Sensor API
  - Overview
  - Reference
  - Sensor
  - Sensor APIs
  - Sensors
---
<div>{{APIRef("Generic Sensor API")}}</div>

<div class="summary">
<p>The Sensor APIs are a set of interfaces built to a common design that expose device sensors in a consistent way to the web platform.</p>
</div>

<h2 id="Sensor_APIs_Concepts_and_Usage">Sensor APIs Concepts and Usage</h2>

<p>Although the Generic Sensor API specification defines a {{domxref('Sensor')}} interface, as a web developer you will never use it. Instead you'll use one of its subclasses to retrieve specific kinds of sensor data. For example, the {{domxref('accelerometer')}} interface returns the acceleration of the device along all three axes at the time it is read.</p>

<p>Sensors may or may not correspond exactly to a physical device sensor. For example, the {{domxref('Gyroscope')}} interface corresponds exactly to a physical device interface. Alternatively, the {{domxref('AbsoluteOrientationSensor')}} interface provides information that is algorithmically agregated from two or more device sensors. These sensor types are referred to as <em>low-level</em> and <em>high-level</em> respectively. The latter type of sensor is also called a fusion sensor (alternatively, virtual or synthetic sensors).</p>

<h3 id="Feature_Detection">Feature Detection</h3>

<p>Sensor interfaces are only proxies for the underlying device sensors. Consequently, feature detection is more complicated for sensors than it is for other APIs. The presence of a sensor API does not tell you whether that API is connected to a real hardware sensor, whether that sensor works, if it's still connected, or even whether the user has granted access to it. Making all this information consistently available is costly to performance and battery life.</p>

<p>Therefore, feature detection for sensor APIs must include both detection of the APIs themselves and <a href="#definsive-programming">defensive programming strategies (see below)</a>.</p>

<p>The examples below show three methods for detecting sensor APIs. Additionally you can put object instantiation inside a {{jsxref('statements/try...catch', 'try...catch')}} block. Notice that detection through the {{domxref('Navigator')}} interface is not one of the available options.</p>

<pre class="brush: js">if (typeof Gyroscope === "function") {
    // run in circles...
}

if ("ProximitySensor" in window) {
    // watch out!
}

if (window.AmbientLightSensor) {
    // go dark...
}</pre>

<h3 id="Defensive_Programming">Defensive Programming</h3>

<p>As stated in Feature Detection, checking for a particular sensor API is insufficient for feature detection. The existence of an actual sensor must be confirmed as well. This is where defensive programming is needed. Defensive programming requires three strategies.</p>

<ul>
 <li>Checking for thrown errors when instantiating a sensor object.</li>
 <li>Listening for errors thrown during its use.</li>
 <li>Handling the errors gracefully so that the user experience is enhanced rather than degraded.</li>
</ul>

<p>The code example below illustrates these principles. The {{jsxref('statements/try...catch', 'try...catch')}} block catches errors thrown during sensor instantiation. It implements a handler for {{domxref('Sensor.onerror')}} to catch errors thrown during use. The only time anything is shown to the user is when <a href="/docs/Web/API/Permissions_API">permissions</a> need to be requested and when the sensor type isn't supported by the device.</p>

<div class="note">
<p>If a feature policy blocks use of a feature it is because your code is inconsistent with the policies set on your server. This is not something that would ever be shown to a user. See {{httpheader('Feature-Policy')}} for implementation instructions.</p>
</div>

<pre class="brush: js">let accelerometer = null;
try {
    accelerometer = new Accelerometer({ referenceFrame: 'device' });
    accelerometer.addEventListener('error', event =&gt; {
        // Handle runtime errors.
        if (event.error.name === 'NotAllowedError') {
            // Branch to code for requesting permission.
        } else if (event.error.name === 'NotReadableError' ) {
            console.log('Cannot connect to the sensor.');
        }
    });
    accelerometer.addEventListener('reading', () =&gt; reloadOnShake(accelerometer));
    accelerometer.start();
} catch (error) {
    // Handle construction errors.
    if (error.name === 'SecurityError') {
        // See the note above about feature policy.
        console.log('Sensor construction was blocked by a feature policy.');
    } else if (error.name === 'ReferenceError') {
        console.log('Sensor is not supported by the User Agent.');
    } else {
        throw error;
    }
}</pre>

<h3 id="Permissions_and_Feature_Policy">Permissions and Feature Policy</h3>

<p>Sensor readings may not be taken unless the user grants permission to a specific sensor type. Do this using the {{domxref('Permissions')}} API. A brief example, shown below, requests permission before attempting to use the sensor.</p>

<pre class="brush: js">navigator.permissions.query({ name: 'accelerometer' })
.then(result =&gt; {
  if (result.state === 'denied') {
    console.log('Permission to use accelerometer sensor is denied.');
    return;
  }
  // Use the sensor.
});</pre>

<p>An alternative approach is to attempt to use the error and listen for the <code>SecurityError</code>.</p>

<pre class="brush: js">const sensor = new AbsoluteOrientationSensor();
sensor.start();
sensor.onerror = event =&gt; {
  if (event.error.name === 'SecurityError')
    console.log("No permissions to use AbsoluteOrientationSensor.");
};</pre>

<p>The following table describes for each sensor type, the name required for the Permissions API, the {{HTMLElement('iframe')}} element's <code>allow</code> attribute and the {{httpheader('Feature-Policy')}} directive.</p>

<table class="standard-table">
 <caption>Sensor permissions</caption>
 <thead>
  <tr>
   <th scope="col">Sensor</th>
   <th scope="col">Permission/Feature Policy Name</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><code>AbsoluteOrientationSensor</code></td>
   <td><code>'accelerometer'</code>, <code>'gyroscope'</code>, and <code>'magnetometer'</code></td>
  </tr>
  <tr>
   <td><code>Accelerometer</code></td>
   <td><code>'accelerometer'</code></td>
  </tr>
  <tr>
   <td><code>AmbientLightSensor</code></td>
   <td><code>'ambient-light-sensor'</code></td>
  </tr>
  <tr>
   <td><code>Gyroscope</code></td>
   <td><code>'gyroscope'</code></td>
  </tr>
  <tr>
   <td><code>LinearAccelerationSensor</code></td>
   <td><code>'accelerometer'</code></td>
  </tr>
  <tr>
   <td><code>Magnetometer</code></td>
   <td><code>'magnetometer'</code></td>
  </tr>
  <tr>
   <td><code>RelativeOrientationSensor</code></td>
   <td><code>'accelerometer'</code>, and <code>'gyroscope'</code></td>
  </tr>
 </tbody>
</table>

<h3 id="Readings">Readings</h3>

<p>Sensor readings are received through the {{domxref('Sensor.onreading')}} callback which is inherited by all sensor types. Reading frequency is decided by you, accomplished with an option passed to a sensor's constructor. The option is a number that specifies the number of readings per second. A whole number or decimal may be used, the latter for frequencies less than a second. The actual reading frequency depends device hardware and consequently may be less than requested.</p>

<p>The following example illustrates this using the {{domxref('Magnetometer')}} sensor.</p>

<pre class="brush: js">let magSensor = new Magnetometer({frequency: 60});

magSensor.addEventListener('reading', e =&gt; {
  console.log("Magnetic field along the X-axis " + magSensor.x);
  console.log("Magnetic field along the Y-axis " + magSensor.y);
  console.log("Magnetic field along the Z-axis " + magSensor.z);
})
magSensor.addEventListener('error', event =&gt; {
  console.log(event.error.name, event.error.message);
})
magSensor.start();
</pre>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{domxref('AbsoluteOrientationSensor')}}{{securecontext_inline}}</dt>
 <dd>Describes the device's physical orientation in relation to the Earth's reference coordinate system.</dd>
 <dt>{{domxref('Accelerometer')}}{{securecontext_inline}}</dt>
 <dd>Provides the acceleration applied to the device along all three axes.</dd>
 <dt>{{domxref('AmbientLightSensor')}}{{securecontext_inline}}</dt>
 <dd>Returns the current light level or illuminance of the ambient light around the hosting device.</dd>
 <dt>{{domxref('Gyroscope')}}{{securecontext_inline}}</dt>
 <dd>Provides the angular velocity of the device along all three axes.</dd>
 <dt>{{domxref('LinearAccelerationSensor')}}{{securecontext_inline}}</dt>
 <dd>Provides the acceleration applied to the device along all three axes, but without the contribution of gravity.</dd>
 <dt>{{domxref('Magnetometer')}}{{securecontext_inline}}</dt>
 <dd>Provides information about the magnetic field as detected by the device’s primary magnetometer sensor.</dd>
 <dt>{{domxref('OrientationSensor')}}{{securecontext_inline}}</dt>
 <dd>The base class for the {{domxref('AbsoluteOrientationSensor')}}. This interface cannot be used directly, instead it provides properties and methods accessed by interfaces that inherit from it.</dd>
 <dt>{{domxref('RelativeOrientationSensor')}}{{securecontext_inline}}</dt>
 <dd>Describes the device's physical orientation without regard to the Earth's reference coordinate system.   </dd>
 <dt>{{domxref('Sensor')}}{{securecontext_inline}}</dt>
 <dd>The base class for all the other sensor interfaces. This interface cannot be used directly. Instead it provides properties, event handlers, and methods accessed by interfaces that inherit from it.</dd>
 <dt>{{domxref('SensorErrorEvent')}}{{securecontext_inline}}</dt>
 <dd>Provides information about errors thrown by a {{domxref('Sensor')}} or related interface.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Generic Sensor')}}</td>
   <td>{{Spec2('Generic Sensor')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('Accelerometer')}}</td>
   <td>{{Spec2('Accelerometer')}}</td>
   <td>Defines <code>Accelerometer</code> and <code>LinearAccerationSensor</code>.</td>
  </tr>
  <tr>
   <td>{{SpecName('AmbientLight')}}</td>
   <td>{{Spec2('AmbientLight')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('Gyroscope')}}</td>
   <td>{{Spec2('Gyroscope')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('Magnetometer')}}</td>
   <td>{{Spec2('Magnetometer')}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName('Orientation Sensor')}}</td>
   <td>{{Spec2('Orientation Sensor')}}</td>
   <td>Defines <code>AbsoluteOrientationSensor</code> and <code>RelativeOrientationSensor</code>.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Sensor")}}</p>
